﻿using System;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using MT4.Utils;
using RGiesecke.DllExport;

namespace MT4.Test
{
    public class Mt4Export
    {
        static string DLLfileName = "MT4.Utils.dll";

        [DllExport("InternalPing", CallingConvention = CallingConvention.StdCall)]
        public static int InternalPing()
        {
            return new InternalPing().Execute();
        }

        [DllExport("ExternalPing", CallingConvention = CallingConvention.StdCall)]
        public static int ExternalPing()
        {
            return new ExternalPing().Execute();
        }

        [DllExport("ExternalPing2", CallingConvention = CallingConvention.StdCall)]
        public static int ExternalPing2()
        {
            int result = -1;

            try
            {
                string DLLpath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
                string fileName = Path.Combine(DLLpath, DLLfileName);

                FileInfo fileInfo = new FileInfo(fileName);
                if (fileInfo.Exists)
                {
                    Assembly assembly = Assembly.LoadFile(fileName);
                    Type type = assembly.GetType("MT4.Utils.ExternalPing");

                    object calcInstance = Activator.CreateInstance(type);

                    result = (int)type.InvokeMember("Execute",
                        BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.Public,
                        null, calcInstance, null);
                }
                else
                {
                    result = -2;
                }
            }
            catch
            {
                result = -3;
            }

            return result;
        }

    }
}